# -*- coding: cp1252 -*-
import os
from os.path import join, isdir

avrs = []
srcdirs = []
subdirs = []
srcfiles = []

def readAvrTypes():
        ''' Read avr types as defined in avrtypes.conf '''
        f = open("avrtargets.conf")
        lines = f.readlines()
        for line in lines:
                if not line.startswith("#"):
                        avrs.append(line[:-1])
        f.close()

def readSrcDirs():
        ''' Read main source dirs as defined in srcdirs.conf '''
        f = open("srcdirs.conf")
        lines = f.readlines()
        for line in lines:
                if  not line.startswith("#"):
                        # line = line[0:-1]
                        srcdirs.append(line[:-1])
        f.close()
        
        for dir in srcdirs:
                findSrcSubdirs(dir)
        

def findSrcSubdirs(srcdir):
        ''' Find all subdirs of the sourcedir provided '''
        items  = os.listdir(srcdir)
        for item in items:
                if isdir(join(srcdir, item)) and not item[0:1] == ".":
                         dir = srcdir + "/" + item
                         findSrcSubdirs(dir)
                         subdirs.append(dir)

def findCppFiles():
        for dir in subdirs:
                items = os.listdir(dir)                
                for item in items:
                        if (not isdir(item)) and item.endswith(".cpp"):
                                srcfiles.append(dir + "/" + item)

def runMakeTest(avr):
        print "XXX Calling make for target " + avr + " XXX"
        ''' Run the make test for the avr architecture provided '''
        SUBDIRS =  '"' + " ".join(subdirs) + '"'
        MCU = avr
        CPPSRC = '"' + ' '.join(srcfiles)+ '"'

        # build the command
        command = "make SUBDIRS:=" + SUBDIRS + " MCU=" + MCU + " CPPSRC=" + CPPSRC + " library"

        # execute the command
        os.system("make clean")
        print(command)
        os.system(command)
        

readAvrTypes()
readSrcDirs()
findCppFiles()

for avr in avrs:
        runMakeTest(avr)
        




